package io.fabric8.openshift.api.model.machineconfig.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ContainerRuntimeConfigurationBuilder extends io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationFluentImpl<io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfiguration,io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationBuilder>{
  public ContainerRuntimeConfigurationBuilder() {
    this(false);
  }
  public ContainerRuntimeConfigurationBuilder(java.lang.Boolean validationEnabled) {
    this(new ContainerRuntimeConfiguration(), validationEnabled);
  }
  public ContainerRuntimeConfigurationBuilder(io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationFluent<?> fluent) {
    this(fluent, false);
  }
  public ContainerRuntimeConfigurationBuilder(io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ContainerRuntimeConfiguration(), validationEnabled);
  }
  public ContainerRuntimeConfigurationBuilder(io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationFluent<?> fluent,io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfiguration instance) {
    this(fluent, instance, false);
  }
  public ContainerRuntimeConfigurationBuilder(io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationFluent<?> fluent,io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfiguration instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLogLevel(instance.getLogLevel()); 
    fluent.withLogSizeMax(instance.getLogSizeMax()); 
    fluent.withOverlaySize(instance.getOverlaySize()); 
    fluent.withPidsLimit(instance.getPidsLimit()); 
    this.validationEnabled = validationEnabled; 
  }
  public ContainerRuntimeConfigurationBuilder(io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfiguration instance) {
    this(instance,false);
  }
  public ContainerRuntimeConfigurationBuilder(io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfiguration instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLogLevel(instance.getLogLevel()); 
    this.withLogSizeMax(instance.getLogSizeMax()); 
    this.withOverlaySize(instance.getOverlaySize()); 
    this.withPidsLimit(instance.getPidsLimit()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfigurationFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.machineconfig.v1.ContainerRuntimeConfiguration build() {
    ContainerRuntimeConfiguration buildable = new ContainerRuntimeConfiguration(fluent.getLogLevel(),fluent.getLogSizeMax(),fluent.getOverlaySize(),fluent.getPidsLimit());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ContainerRuntimeConfigurationBuilder that = (ContainerRuntimeConfigurationBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}